import moment from "moment";

let getNomeAgp = function (agp, key, grupoPrato) {
	if (!agp.NMAGRUPGRPRAT && grupoPrato.find(g => g.CDAGRUPGRPRAT == key)) {
		agp.NMAGRUPGRPRAT = grupoPrato.find(g => g.CDAGRUPGRPRAT == key).NMAGRUPGRPRAT
	}
	if (key != "null") {
		if (agp.NMAGRUPGRPRAT != undefined) {
			return `${key} - ${agp.NMAGRUPGRPRAT}`;
		} else {
			return `${key}`;
		}
	} else {
		return `SEM AGRUPAMENTO`;
	}
};

let getGPPratoNome = function (grupo) {
	let NOM_GRUPOPRATO = null;
	let gppratoNome = null;
	let gp = grupo.find(g => g.gppratoNome || g.NOM_GRUPOPRATO);
	NOM_GRUPOPRATO = gp.NOM_GRUPOPRATO;
	gppratoNome = gp.gppratoNome;

	return `${gppratoNome || NOM_GRUPOPRATO}`;
};

let mountAnalPratUtil = function (grupo, gpname, utps, fromAGP = null) {
	let data = [
		[`Obrigatório - ✔ | Restrição - Ø`, "S", "T", "Q", "Q", "S", "S", "D", "PS", "2S", "3S", "4S", "US", "Fer"]
	];

	if (!fromAGP) {
		let utCurGP = utps.find(u => u.NUM_GRP_PRATO == grupo);
		if (utCurGP) {
			let keys = Object.keys(utCurGP).filter(k => k.includes("IND_") || k.includes("ID"));
			let upgp = [utCurGP.NOME_GRUPO];
			keys.forEach(k => {
				if (utCurGP[k] == "P") {
					upgp.push({
						ut: " ",
						tit: "Preferencial"
					});
				} else if (utCurGP[k] == "O") {
					upgp.push({
						ut: "✔",
						tit: "Obrigatório"
					});
				} else {
					upgp.push({
						ut: "Ø",
						tit: "Restrito"
					});
				}
			});
			data.push(upgp);
		} else {
			data.push([
				gpname,
				{
					ut: " ",
					tit: "Preferencial"
				},
				{
					ut: " ",
					tit: "Preferencial"
				},
				{
					ut: " ",
					tit: "Preferencial"
				},
				{
					ut: " ",
					tit: "Preferencial"
				},
				{
					ut: " ",
					tit: "Preferencial"
				},
				{
					ut: " ",
					tit: "Preferencial"
				},
				{
					ut: " ",
					tit: "Preferencial"
				}
			]);
		}
	} else {}
	return data;
};

let ajustPratosForHint = function (frequencias, grupo, platesPrice, utilizacaoPratoSemana, firstArr = null, ) {
	let showData = "";
	let data = [];
	if (firstArr) {
		data = [firstArr];
	}
	for (let i = 0; i < grupo.length; i++) {
		let prato = grupo[i];
		let freq = frequencias.find(
			f =>
			f.COD_PRATO &&
			(f.COD_PRATO == prato.codprato || f.COD_PRATO == prato.COD_PRATO)
		);
		let desc = `${prato.nomePrato || prato.NMPRATO} \n`;
		desc += `${
        prato.NM_TP_CORTE ? "TP CORTE: " + prato.NM_TP_CORTE + "\n" : ""
      }`;
		desc += `${
        prato.NM_MODO_PREPARO
          ? "MODO PREPARO: " + prato.NM_MODO_PREPARO + "\n"
          : ""
      }`;
		desc += `${
        prato.NM_INGR_PRINCIPAL_1
          ? "INGR PRINCIPAL 1: " + prato.NM_INGR_PRINCIPAL_1 + "\n"
          : ""
      }`;
		desc += `${
        prato.NM_INGR_PRINCIPAL_2
          ? "INGR PRINCIPAL 2: " + prato.NM_INGR_PRINCIPAL_2 + "\n"
          : ""
      }`;

		data.push({
			utilizacao: mountAnalPratUtil(prato.gpprato || prato.NUM_GRP_PRATO, prato.gppratoNome || prato.NOM_GRUPOPRATO, utilizacaoPratoSemana),
			agpprato: prato.CDAGRUPGRPRAT,
			gpprato: prato.gpprato || prato.NUM_GRP_PRATO,
			prato: prato.nomePrato || prato.NMPRATO,
			desc: desc,
			freqMin: freq ? freq.MIN_MES_PRATO : "--",
			freqMax: freq ? freq.MAX_MES_PRATO : "--",
			freqSem: freq ? freq.MAX_SEMANA : "--",
			valor: prato.VLR_CUSTO_PRATO ?
				"R$ " +
				parseFloat(prato.VLR_CUSTO_PRATO)
				.toFixed(5)
				.replace(".", ",") : "--",
			percapta: prato.codprato && platesPrice[prato.codprato] ?
				"R$ " +
				platesPrice[prato.codprato]
				.toFixed(5)
				.toString()
				.replace(".", ",") : "--",
			qntprato: prato.datas ? prato.datas.length : 0
		});
	}
	return data;
};
let getPratosUsados = function (agrup, frequencias, platesPrice, utilizacaoPratoSemana) {
	let firstItem = {
		prato: "Prato",
		freqMin: "Mínimo (mês)",
		freqMax: "Máximo (mês)",
		freqSem: "Máximo (semana)",
		valor: "Custo unit.",
		percapta: "Per capita (médio)",
		qntprato: "Incidência"
	};
	let agrupPlateList = [firstItem];
	let showData = "";


	let gpList = Object.keys(agrup.GRUPOS);
	for (let i = 0; i < gpList.length; i++) {
		let grupoAgp = agrup.GRUPOS[gpList[i]];
		ajustPratosForHint(frequencias, grupoAgp, platesPrice, utilizacaoPratoSemana).forEach(dataAj => {
			agrupPlateList.push(dataAj);
		});
	}


	agrupPlateList.sort((a, b) => {
		if (a.qntprato >= b.qntprato) {
			return -1;
		}
		return 1;
	});
	return agrupPlateList;
};

let getFrequenciasGPPRATO = function (frequencias, gpprato, gp, platesPrice) {
	let gpCust = platesPrice["G" + gpprato] ?
		"R$ " +
		platesPrice["G" + gpprato]
		.toFixed(5)
		.toString()
		.replace(".", ",") :
		"--";

	let freq = frequencias.find(f => f.NUM_GRP_PRATO == gpprato);
	if (freq) {
		if (!freq.cur) {
			freq.cur = "--";
		}
		// if (
		//     freqControl &&
		//     (freq.cur < freq.MIN_MES_GRP || freq.cur > freq.MAX_MES_GRP)
		// ) {
		//     freqControl[gpprato] = true;
		// }
		return [
			freq.MIN_MES_GRP,
			freq.MAX_MES_GRP,
			freq.MAX_SEM_GRP,
			freq.cur,
			gpCust,
			freq.curWeekUsage
		];
	} else {}
	let gpcod = Object.keys(gp);
	let cont = 0;
	for (let i = 0; i < gpcod.length; i++) {
		if (gp[gpcod[i]].datas) {
			cont = cont + parseInt(gp[gpcod[i]].datas.length);
		}
	}

	return ["--", "--", "--", cont != 0 ? cont : "--", gpCust, "--"];
};

let feedFreqData = function (cardData) {
	let allAgrup = {};
	let allPlates = [];
	let platesPrice = {};

	let total = 0;
	let allAgrupAux = {};
	let frequencias = cardData.frequencias;
	let utilizacaoPratoSemana = cardData.utilizacaoPratoSemana;
	let grupoPrato = cardData.grupoPrato;
	let seqInfo = cardData.cardapio.datas.find(sq => !!sq.seqInfo) || [];

	let pratosLength = cardData.tabela.pratos.length;
	if (
		cardData &&
		cardData.tabela &&
		cardData.tabela.pratos &&
		cardData.grupoPrato &&
		seqInfo
	) {
		seqInfo = seqInfo.seqInfo || [];
		let grpInSeq = [];
		seqInfo.forEach(s => {
			s.NUM_GRP_PRATO.forEach(sg => {
				if (!grpInSeq.includes(sg)) {
					grpInSeq.push(sg);
				}
			});
		});

		for (let i = 0; i < pratosLength; i++) {
			const dia = cardData.tabela.pratos[i];
			for (let j = 0; j < dia.length; j++) {
				const prato = dia[j];
				if (prato.codprato) {
					let dia = cardData.tabela.comensais_datas[i][1];
					let _p = Object.assign({}, prato);
					delete _p.prods;
					allPlates.push(_p);

					let curAllAgup = Object.keys(allAgrupAux);
					if (!curAllAgup.includes(_p.CDAGRUPGRPRAT)) {
						allAgrupAux[_p.CDAGRUPGRPRAT] = {
							CDAGRUPGRPRAT: _p.CDAGRUPGRPRAT,
							NMAGRUPGRPRAT: _p.NMAGRUPGRPRAT,
							GRUPOS: {}
						};
						allAgrupAux[_p.CDAGRUPGRPRAT]["GRUPOS"][_p.gpprato] = [];
					} else {
						let curAllGrup = Object.keys(
							allAgrupAux[_p.CDAGRUPGRPRAT]["GRUPOS"]
						);
						if (!curAllGrup.includes(_p.gpprato)) {
							allAgrupAux[_p.CDAGRUPGRPRAT]["GRUPOS"][_p.gpprato] = [];
							_p.datas = [];
							_p.datas.push(dia);
							allAgrupAux[_p.CDAGRUPGRPRAT]["GRUPOS"][_p.gpprato].push(_p);
						}
					}
					let pratosOnGP = allAgrupAux[_p.CDAGRUPGRPRAT]["GRUPOS"][_p.gpprato];
					if (pratosOnGP.find(pgp => pgp.codprato == _p.codprato)) {
						if (
							!pratosOnGP
							.find(pgp => pgp.codprato == _p.codprato)
							.datas.includes(dia)
						) {
							pratosOnGP
								.find(pgp => pgp.codprato == _p.codprato)
								.datas.push(dia);
						}
					} else {
						_p.datas = [];
						_p.datas.push(dia);
						allAgrupAux[_p.CDAGRUPGRPRAT]["GRUPOS"][_p.gpprato].push(_p);
					}
				}
			}
		}

		for (let i = 0; i < grupoPrato.length; i++) {
			let pratoFGP = grupoPrato[i];
			if (grpInSeq.includes(pratoFGP.NUM_GRP_PRATO)) {
				if (allAgrupAux[pratoFGP.CDAGRUPGRPRAT]) {
					if (
						allAgrupAux[pratoFGP.CDAGRUPGRPRAT]["GRUPOS"][pratoFGP.NUM_GRP_PRATO]
					) {
						if (
							!allAgrupAux[pratoFGP.CDAGRUPGRPRAT]["GRUPOS"][
								pratoFGP.NUM_GRP_PRATO
							].find(p => p.codprato == pratoFGP.COD_PRATO)
						) {
							allAgrupAux[pratoFGP.CDAGRUPGRPRAT]["GRUPOS"][
								pratoFGP.NUM_GRP_PRATO
							].push(pratoFGP);
						}
					} else {
						allAgrupAux[pratoFGP.CDAGRUPGRPRAT]["GRUPOS"][
							pratoFGP.NUM_GRP_PRATO
						] = [];
						allAgrupAux[pratoFGP.CDAGRUPGRPRAT]["GRUPOS"][
							pratoFGP.NUM_GRP_PRATO
						].push(pratoFGP);
					}
				} else {
					allAgrupAux[pratoFGP.CDAGRUPGRPRAT] = {
						GRUPOS: {}
					};
					allAgrupAux[pratoFGP.CDAGRUPGRPRAT]["GRUPOS"][
						pratoFGP.NUM_GRP_PRATO
					] = [];
					allAgrupAux[pratoFGP.CDAGRUPGRPRAT]["GRUPOS"][
						pratoFGP.NUM_GRP_PRATO
					].push(pratoFGP);
				}
			}
		}
	}
	let keys = Object.keys(allAgrupAux);
	keys.sort(function (a, b) {
		if (a < b) {
			return -1;
		}
		return 1;
	});
	for (let i = 0; i < keys.length; i++) {
		const key = keys[i];
		allAgrup[key] = allAgrupAux[key];
	}

	let comensdivtotal = 0;
	cardData.cardapio.datas.forEach(d => {
		comensdivtotal += parseFloat(d.comenDIV);
	});
	cardData.cardapio.datas.forEach(d => {

		d.pratos.forEach(p => {
			let comensaisPrato = (parseFloat(d.comensais) * p.percentualConsumo) / 100;
			let custoPerCapita =
				(comensaisPrato * p.VLR_CUSTO_PRATO) / comensdivtotal;

			if (!platesPrice["G" + p.gpprato]) {
				platesPrice["G" + p.gpprato] = 0;
			}
			if (!platesPrice["AP" + p.CDAGRUPGRPRAT]) {
				platesPrice["AP" + p.CDAGRUPGRPRAT] = 0;
			}
			if (!platesPrice[p.codprato]) {
				platesPrice[p.codprato] = 0;
			}

			platesPrice[p.codprato] += custoPerCapita;
			platesPrice["G" + p.gpprato] += custoPerCapita;
			platesPrice["AP" + p.CDAGRUPGRPRAT] += custoPerCapita;
		});
	});

	Object.keys(allAgrup).forEach(key => {
		let agp = allAgrup[key];
		allAgrup[key].NMEXIB = getNomeAgp(agp, key, grupoPrato);
		allAgrup[key].agrupPlateList = getPratosUsados(agp, frequencias, platesPrice, utilizacaoPratoSemana);

		let custPercAGP = platesPrice["AP" + agp.CDAGRUPGRPRAT] ? platesPrice["AP" + agp.CDAGRUPGRPRAT].toFixed(5).toString().replace(".", ",") : "";
		if (custPercAGP) {
			custPercAGP = "R$ " + custPercAGP;
		} else {
			custPercAGP = "--";
		}
		let apfreq = [0, 0, 0, 0, custPercAGP];
		let gpcod = Object.keys(agp.GRUPOS);

		for (let i = 0; i < gpcod.length; i++) {
			let gp = agp.GRUPOS[gpcod[i]];
			let frCount = getFrequenciasGPPRATO(frequencias, gpcod[i], gp, platesPrice);
			let [ MIN_MES_GRP, MAX_MES_GRP, MAX_SEM_GRP, cur, gpCust, curWeekUsage] = frCount;
			let invalidWeekUsage = curWeekUsage && typeof curWeekUsage !== 'string' ? Object.values(curWeekUsage).some( usage => usage > MAX_SEM_GRP) : false;
			allAgrup[key].GRUPOS[gpcod[i]].freq = frCount;
			allAgrup[key].GRUPOS[gpcod[i]].freqError = cur < MIN_MES_GRP || cur > MAX_MES_GRP;
			allAgrup[key].GRUPOS[gpcod[i]].freqErrorWeek = invalidWeekUsage;
			allAgrup[key].GRUPOS[gpcod[i]].NMEXIB = getGPPratoNome(gp);

			for (let j = 0; j < frCount.length - 1; j++) {
				if (frCount[j] != "--") {
					apfreq[j] = apfreq[j] + parseInt(frCount[j]);
				}
			}
		}
		for (let j = 0; j < apfreq.length - 1; j++) {
			apfreq[j] = apfreq[j] == 0 ? "--" : apfreq[j];
		}

		allAgrup[key].freq = apfreq;
	});

	seqInfo.sort((a, b) => {
		if (parseInt(a.NUM_SEQUENCIA) > parseInt(b.NUM_SEQUENCIA)) {
			return 1;
		}
		return -1
	});

	let header = [{
			'name': 'Grupo de Prato',
			'pivot': 'gpprato'
		},
		{
			'name': 'Min (Mês)',
			'pivot': 'freqMin'
		},
		{
			'name': 'Max (Mês)',
			'pivot': 'freqMax'
		},
		{
			'name': 'Max (Sem)',
			'pivot': 'freqMaxSem'
		},
		{
			'name': '#',
			'pivot': 'inc'
		}
	];
	let seqList = [];
	seqInfo.forEach(s => {
		seqList.push({
			name: s.NMTIPOPRAT,
			sequencial: s.NUM_SEQUENCIA
		});
	});

	let plateList = [];
	cardData.tabela.pratos.forEach(d => {
		d.forEach(p => {
			if (p.prato) {
				plateList.push(p);
			}
		})
	});

	Object.entries(allAgrup).forEach((agpData) => {
		allAgrup[agpData[0]].distribution_of_incidences = [
			[].concat(header, seqList)
		];

		let totaldata = ['Total', allAgrup[agpData[0]].freq[0], allAgrup[agpData[0]].freq[1], allAgrup[agpData[0]].freq[2], allAgrup[agpData[0]].freq[3]];
		let seqData = {};

		Object.entries(allAgrup[agpData[0]]['GRUPOS']).forEach((gpdata) => {
			let gpprato = gpdata[0]
			let data = [gpdata[1].NMEXIB, gpdata[1].freq[0], gpdata[1].freq[1], gpdata[1].freq[2], gpdata[1].freq[3]];

			seqList.forEach(s => {
				let rawVal = plateList.filter(p => p.sequencial == s.sequencial && p.gpprato == gpprato).length.toString();
				let isOnSeq = seqInfo.find(_s=> _s.NUM_SEQUENCIA == s.sequencial).NUM_GRP_PRATO.indexOf(gpprato) >= 0;

				let incidencies = {
					value: isOnSeq ? rawVal : 'Ø',
					sequencial: s.sequencial
				};
				
				let incidenciesValue = incidencies.value == 'Ø' ? 0 : incidencies.value;

				if(seqData[s.sequencial]){
					seqData[s.sequencial] =  seqData[s.sequencial] + parseInt(incidenciesValue);
				}else{
					seqData[s.sequencial] = parseInt(incidenciesValue);
				}

				data.push(incidencies);
			});

			allAgrup[agpData[0]].distribution_of_incidences.push(data);
		});

		seqList.forEach(s => {
			totaldata.push({
				sequencial: s.sequencial,
				value: seqData[s.sequencial]
			});
		});

		allAgrup[agpData[0]].distribution_of_incidences.push(totaldata);

		totaldata = totaldata.filter(td => td.value != 0);
		totaldata = totaldata.map(td => td.sequencial);
		let itensWithData = []; totaldata.forEach(t=> {if(t)itensWithData.push(t)});

		allAgrup[agpData[0]].distribution_of_incidences.forEach((rows, key) => {
			allAgrup[agpData[0]].distribution_of_incidences[key] = JSON.parse(JSON.stringify(rows.filter(item => {
				if((itensWithData.indexOf(item.sequencial) >= 0 || !item.sequencial) || typeof item != 'object'){
					return item;
				}
			})));
		});

	});
	return allAgrup;
};

let getRandomColor = function (usColors) {
	var letters = "0123456789ABCDEF";
	var color = "#";
	for (var i = 0; i < 6; i++) {
		color += letters[Math.floor(Math.random() * 16)];
	}
	if (usColors.includes(color)) {
		return this.getRandomColor(usColors);
	}
	return color;
}

let feedINGData = function (cardData) {
	let usColors = [];
	let ings = {};
	let dias = cardData.tabela.pratos;
	for (let i = 0; i < dias.length; i++) {
		let pratos = dias[i];
		for (let j = 0; j < pratos.length; j++) {
			let prato = pratos[j];
			if (prato.prato) {
				if (prato.INGR_PRINCIPAL_1 && !Object.keys(ings).includes(prato.INGR_PRINCIPAL_1)) {
					let color = getRandomColor(usColors);
					ings[prato.INGR_PRINCIPAL_1] = color;
					usColors.push(color);
				}
				if (prato.INGR_PRINCIPAL_2 && !Object.keys(ings).includes(prato.INGR_PRINCIPAL_2)) {
					let color = getRandomColor(usColors);
					ings[prato.INGR_PRINCIPAL_2] = color;
					usColors.push(color);
				}

			}

		}
	}
	return ings;
};

let generateCardExcell = function (tabela, numero) {
	let trad = {
		Mon: "Seg",
		Tue: "Ter",
		Wed: "Qua",
		Thu: "Qui",
		Fri: "Sex",
		Sat: "Sab",
		Sun: "Dom",
	};
	let dias = tabela.comensais_datas.length;
	let data = [];
	let label = [{
			header: "Comensais Estimados",
			key: "comens"
		},
		{
			header: "Data",
			key: "data"
		},
	];

	tabela.pratos[0].forEach(p => {
		label.push({
			header: p.name,
			key: 'seq' + p.sequencial
		})
	});

	label = label.concat([{
			header: "PU. DIA",
			key: "pud"
		},
		{
			header: "PU. ACUMULADO",
			key: "puac"
		},
	]);

	for (let i = 1; i < dias; i++) {
		let newData = {
			comens: tabela.comensais_datas[i][0],
			data: tabela.comensais_datas[i][1],
			pud: tabela.pudia_puacu[i][0] != 0 ? parseFloat(tabela.pudia_puacu[i][0]).toFixed(5) : '0',
			puac: tabela.pudia_puacu[i][1] && tabela.pudia_puacu[i][1] != 0 ? parseFloat(tabela.pudia_puacu[i][1]).toFixed(5) : '0',
		};
		newData.data = moment(newData.data, "DD/MM/YYYY").format("DD") + " " + trad[moment(newData.data, "DD/MM/YYYY").format("ddd")];
		tabela.pratos[i].forEach(p => {
			newData['seq' + p.sequencial] = '--';
			if (p.nomePrato) {
				newData['seq' + p.sequencial] = parseFloat(p.percentualConsumo).toFixed(2) + '%' + ' ' + p.nomePrato;
				if (numero) {
					newData['seq' + p.sequencial] = ((parseFloat(newData.comens) * parseFloat(p.percentualConsumo)) / 100).toFixed(2) + ' ' + p.nomePrato;
				}
			}
		});

		data.push(newData);
	}
	return {
		label,
		data
	};
};

let addIncidencia_tp_gp_prato = (dataFromOtm) => {
	const begining = performance.now()
	let formatMes = (DTMESCARD) => {
		return moment(DTMESCARD, 'DD/MM/YYYY HH:mi:ss').format('MM/YY');
	}

	let incidencias = dataFromOtm.incidencia_tp_gp_prato.data;

	let incidenciaTabela = [];

	let meses = [];
	let cdtippratovis = [];

	incidencias.forEach(i => {
		i.DTMESCARD = formatMes(i.DTMESCARD);

		if (meses.indexOf(i.DTMESCARD) < 0) {
			meses.push(i.DTMESCARD);
		}
	});

	incidencias.forEach(i => {
		if (cdtippratovis.indexOf(i.CDTIPOPRAT) < 0) {
			cdtippratovis.push(i.CDTIPOPRAT);

			let firstTpPrato = {
				ID: i.CDTIPOPRAT,
				NM: i.NMTIPOPRAT,
				isTPPRATO: true,
				pivo: i.CDTIPOPRAT,
				COD_TIP_PRATO: i.CDTIPOPRAT
			};
			let curTipoPratList = incidencias.filter(ift => i.CDTIPOPRAT == ift.CDTIPOPRAT);

			meses.forEach(m => {
				firstTpPrato['mediaPU'] = firstTpPrato['mediaPU'] ? firstTpPrato['mediaPU'] : 0;

				let curTipoPrat = curTipoPratList.find(ift => ift.DTMESCARD == m);
				if (curTipoPrat) {
					firstTpPrato['qtde' + m] = curTipoPrat.QTDE_TPPRAT;
					firstTpPrato['cons' + m] = curTipoPrat.CONSUMO_TPPRAT;
					firstTpPrato['pu' + m] = parseFloat(curTipoPrat.PU_TPPRAT).toFixed(5);
					firstTpPrato['mediaPU'] += parseFloat(parseFloat((parseFloat(curTipoPrat.PU_TPPRAT) / (meses.length))).toFixed(5));
				}
			});

			incidenciaTabela.push(firstTpPrato);

			let newGppratoList = [];

			meses.forEach(m => {
				curTipoPratList.filter(ift => ift.DTMESCARD == m).forEach(mi => {

					let curgpprato = newGppratoList.find(gp => gp.pivo == mi.NRGRUPOPRATOSERV && gp.COD_TIP_PRATO == firstTpPrato.COD_TIP_PRATO) || {
						//ID: mi.CDGRUPOPRATO,
						NM: mi.NMGRUPOPRATO,
						pivo: mi.NRGRUPOPRATOSERV,
						COD_TIP_PRATO: firstTpPrato.COD_TIP_PRATO
					};

					curgpprato['qtde' + m] = mi.QTDE_GPPRATO;
					curgpprato['cons' + m] = mi.CONSUMO_GPPRATO;
					curgpprato['pu' + m] = parseFloat(mi.PU_GPPRATO).toFixed(5);

					curgpprato['mediaPU'] = curgpprato['mediaPU'] ? curgpprato['mediaPU'] : 0;
					curgpprato['mediaPU'] += parseFloat((parseFloat((parseFloat(mi.PU_GPPRATO) / (meses.length))).toFixed(5)));


					curgpprato.plateList = curgpprato.plateList || [];
					let prato = {
						ID: `${i.CDFILAUXPRAT}${i.CDPRATO}`,
						NM: i.NMPRATO,
						pivo: `${i.CDFILAUXPRAT}${i.CDPRATO}`,
						COD_TIP_PRATO: i.CDTIPOPRAT,
						NRGRUPOPRATOSERV: i.NRGRUPOPRATOSERV,
					};

					prato['qtde' + m] = i.QTDE_PRATO;
					prato['cons' + m] = i.CONSUMO_PRATO;
					prato['pu' + m] = parseFloat(i.PU_PRATO).toFixed(5);

					prato['mediaPU'] = prato['mediaPU'] || 0;
					prato['mediaPU'] += parseFloat((parseFloat((parseFloat(i.PU_PRATO) / (meses.length))).toFixed(5)));

					if (i.NRGRUPOPRATOSERV == prato.NRGRUPOPRATOSERV) {
						if (!curgpprato.plateList.find(pl => pl.ID == prato.ID)) {
							curgpprato.plateList.push(prato);
						}
					}

					if (!newGppratoList.find(gp => gp.pivo == mi.NRGRUPOPRATOSERV /* && gp.pivo == firstTpPrato.COD_TIP_PRATO */ )) {
						newGppratoList.push(curgpprato);
					}


				});
			});

			incidenciaTabela[incidenciaTabela.length - 1].gplist = newGppratoList;
			newGppratoList = [];
		}
	});

	dataFromOtm.incidencia = {
		incidenciaTabela,
		meses
	};
	return dataFromOtm;
};

// https://stackoverflow.com/a/34890276
const _groupBy = function (xs, key) {
	return xs.reduce(function (rv, x) {
		(rv[x[key]] = rv[x[key]] || []).push(x);
		return rv;
	}, {});
};

const _sum = (list, key) => list.reduce((a, b) => a[key] + b[key], 0);

const _average = (list, key) => (_sum(list, key) / list.length) || 0;

const _formatMes = (DTMESCARD) => {
	return moment(DTMESCARD, 'DD/MM/YYYY HH:mi:ss').format('MM/YY');
}
const _getPUAverageFromObject = (dataObject, lastMonthKey) => {
	const keysForAverage = Object.keys(dataObject).
	filter(k => k !== lastMonthKey && k.indexOf("pu") === 0)
	if (keysForAverage.length > 0) {
		const sum = keysForAverage.
		map(k => parseFloat(dataObject[k])).
		reduce((agg, c) => agg + c)

		return sum / keysForAverage.length
	} else {
		return null
	}
}

const _weightedAverage = (a, weight, b) => {
	return (a * weight + b) / (weight + 1)
}
addIncidencia_tp_gp_prato = (dataFromOtm) => {
	const {
		incidencia_tp_gp_prato
	} = dataFromOtm
	const begining = performance.now()
	const incidencias = incidencia_tp_gp_prato.data.map(i => ({
		...i,
		DTMESCARD: _formatMes(i.DTMESCARD)
	}))

	const meses = {}
	incidencias.forEach(i => {
		meses[i.DTMESCARD] = true
	})
	const monthsArray = Object.keys(meses)
	const lastMonth = monthsArray[monthsArray.length - 1]
	console.log(meses, lastMonth)

	const incidenciasGroupedByPlateType = _groupBy(incidencias, 'CDTIPOPRAT');
	const incidenciasGroupedByPlateGroup = Object.values(incidenciasGroupedByPlateType).
	map(platesGroupedByPlateType => {
		return _groupBy(platesGroupedByPlateType, 'CDGRUPOPRATO')
	})


	const incidenciasGroupedByPlate = incidenciasGroupedByPlateGroup.
	map((plateGroups) => {
		const plateGroupsArray = Object.values(plateGroups);

		const firstPlateInType = plateGroupsArray[0][0]

		const plateTypeData = {
			ID: firstPlateInType.CDTIPOPRAT,
			pivo: firstPlateInType.CDTIPOPRAT,
			COD_TIP_PRATO: firstPlateInType.CDTIPOPRAT,
			NM: firstPlateInType.NMTIPOPRAT,
			isTPPRATO: true,
		}

		const gplist = plateGroupsArray.
		map(platesGroupedByPlateGroup => {

			const firstPlateData = platesGroupedByPlateGroup[0]
			const groupData = {
				NM: firstPlateData.NMGRUPOPRATO,
				pivo: firstPlateData.NRGRUPOPRATOSERV,
				COD_TIP_PRATO: firstPlateData.CDTIPOPRAT
			}
			const platesInGroup = {}
			platesGroupedByPlateGroup.forEach(plate => {

				const {
					CDFILAUXPRAT,
					CDPRATO
				} = plate
				const plateKey = CDFILAUXPRAT + CDPRATO
				const previousPlateInfo = platesInGroup[plateKey] || {}
				const currentMonth = plate.DTMESCARD
				const platePU = parseFloat(plate.PU_PRATO)
				const currentPUAverage = previousPlateInfo.mediaPU || 0

				let monthsUsedInAverage = previousPlateInfo.monthsUsedInAverage || 0
				let averagePU = currentPUAverage

				if (currentMonth !== lastMonth) {
					averagePU = _weightedAverage(currentPUAverage, monthsUsedInAverage, platePU)
					monthsUsedInAverage = monthsUsedInAverage + 1
				}
				platesInGroup[plateKey] = {
					...previousPlateInfo,
					ID: plateKey,
					pivo: plateKey,
					NM: plate.NMPRATO,
					NRGRUPOPRATOSERV: plate.NRGRUPOPRATOSERV,
					COD_TIP_PRATO: plate.CDTIPOPRAT,
					["qtde" + currentMonth]: plate.QTDE_PRATO,
					["cons" + currentMonth]: plate.CONSUMO_PRATO,
					["pu" + currentMonth]: platePU,
					mediaPU: averagePU,
					monthsUsedInAverage
				}

				groupData["qtde" + currentMonth] = plate.QTDE_GPPRATO
				groupData["cons" + currentMonth] = plate.CONSUMO_GPPRATO
				groupData["pu" + currentMonth] = parseFloat(plate.PU_GPPRATO)


				plateTypeData["qtde" + currentMonth] = plate.QTDE_TPPRAT
				plateTypeData["cons" + currentMonth] = plate.CONSUMO_TPPRAT
				plateTypeData["pu" + currentMonth] = parseFloat(plate.PU_TPPRAT)

			})

			return {
				...groupData,
				mediaPU: _getPUAverageFromObject(groupData, `pu${lastMonth}`),
				plateList: Object.values(platesInGroup)
			}
		})
		return {
			...plateTypeData,
			mediaPU: _getPUAverageFromObject(plateTypeData, `pu${lastMonth}`),
			gplist
		}
	})

	console.log(incidenciasGroupedByPlate, `took ${performance.now() - begining}`)

	dataFromOtm.incidencia = {
		"incidenciaTabela": incidenciasGroupedByPlate,
		"meses": Object.keys(meses),
	}
	return dataFromOtm
}
const _getPlateTypeObjectFromPlate = function (plate, colInfo) {
	const plateKey = plate.unidadePrato + plate.prato

	const plateList = [{
		ID: plateKey,
		pivo: plateKey,
		NM: plate.nomePrato,
		comenDIV: plate.comenDIV,
		comensais: plate.comensais,
		NRGRUPOPRATOSERV: plate.gpprato
	}]

	const gplist = [{
		COD_TIP_PRATO: plate.COD_TIP_PRATO,
		pivo: plate.COD_GRP_TIP_PRATO,
		NM: plate.NOME_GRP_TIP_PRATO,
		plateList
	}]

	const plateTypeName = colInfo.find((col) => {
		return col.sequencial === plate.sequencial
	}).name

	const plateType = {
		NM: plateTypeName,
		ID: plate.COD_TIP_PRATO,
		pivo: plate.COD_TIP_PRATO,
		COD_TIP_PRATO: plate.COD_TIP_PRATO,
		isTPPRATO: true,
		gplist
	}

	return plateType
};
let generateCompExcell = function (dias, incidencia, colInfo) {

	let allplates = [];
	let comensaisDIVTotal = 0;
	let consumoTotal = {};
	dias.forEach((d) => {
		comensaisDIVTotal += parseFloat(d.comenDIV);
		const dayKey = d.dia;
		consumoTotal[dayKey] = consumoTotal[dayKey] ? consumoTotal[dayKey] : {};
		(d.pratos || []).forEach(function (p) {
			if (p.prato) {
				consumoTotal[d.dia][p.COD_TIP_PRATO] = consumoTotal[d.dia][p.COD_TIP_PRATO] || 0;
				consumoTotal[d.dia][p.COD_TIP_PRATO] += parseFloat(p.percentualConsumo);
				let prato = JSON.parse(JSON.stringify(p));
				prato.comenDIV = parseFloat(d.comenDIV);
				prato.comensais = parseFloat(d.comensais);
				allplates.push(prato);
			}
		});
	});

	let contIncidenciaTipoPrato = {}
	let mediaIncidenciaTipoPrato = {}

	Object.entries(consumoTotal).forEach(([dia, tiposDePrato]) => {
		Object.entries(tiposDePrato).forEach(([tipoDePrato, consumo]) => {
			mediaIncidenciaTipoPrato[tipoDePrato] = mediaIncidenciaTipoPrato[tipoDePrato] || 0;
			mediaIncidenciaTipoPrato[tipoDePrato] += parseFloat(consumo);

			contIncidenciaTipoPrato[tipoDePrato] = contIncidenciaTipoPrato[tipoDePrato] ?
				contIncidenciaTipoPrato[tipoDePrato] + 1 : 1;

		})
	});


	let incListCopy = Object.assign({}, incidencia);
	let incidenciaTabela = null;
	let meses = null;

	incidenciaTabela = incListCopy.incidenciaTabela;
	meses = incListCopy.meses;
	const monthToRenderPUAverage = [...meses]
	const lastMonth = monthToRenderPUAverage.pop()

	let label = [{
			header: "Cód. Coluna",
			key: "ID"
		},
		{
			header: "Nom. Coluna/ Grupo",
			key: "NM"
		},
	];

	meses.forEach(m => {
		label.push({
			header: "QTDE " + m,
			key: 'qtde' + m
		});
	});

	label.push({
		header: "QTDE OTM",
		key: 'qtdeotm'
	});

	meses.forEach(m => {
		label.push({
			header: "CONS " + m,
			key: 'cons' + m
		});
	});

	label.push({
		header: "CONS OTM",
		key: 'consotm'
	});

	monthToRenderPUAverage.forEach(m => {
		label.push({
			header: "PU " + m,
			key: 'pu' + m
		});
	});

	label.push({
		header: "Media PU",
		key: 'mediaPU'
	});

	label.push({
		header: "PU OTM",
		key: 'puotm'
	});

	label.push({
		header: "PU OTM - Media PU",
		key: 'puotmmediapu'
	});

	label.push({
		header: "PU " + lastMonth,
		key: "pu" + lastMonth
	});

	label.push({
		header: "PU OTM - PU " + meses[meses.length - 1],
		key: 'puotmmescorrente'
	});

	allplates.forEach(p => {
		let tpprat = incidenciaTabela.find(it => p.COD_TIP_PRATO == it.pivo);
		if (!tpprat) {
			tpprat = _getPlateTypeObjectFromPlate(p, colInfo)
			incidenciaTabela.push(tpprat)
		}
		if (tpprat) {
			let inctpprat = allplates.filter(it => p.COD_TIP_PRATO == it.COD_TIP_PRATO);
			tpprat.qtdeotm = tpprat.qtdeotm ? tpprat.qtdeotm + 1 : 1;
			tpprat.consotm = 0;
			tpprat.puotm = 0;

			inctpprat.forEach(ap => {
				tpprat.consotm += parseFloat(ap.percentualConsumo);
				tpprat.puotm += parseFloat(ap.custoPerCapita);
			});

			tpprat.consotm = tpprat.consotm / inctpprat.length;
			tpprat.puotm = tpprat.puotm / inctpprat.length;

			let agpmen = tpprat.gplist.find(gplistItem => p.gpprato == gplistItem.pivo && p.COD_TIP_PRATO == gplistItem.COD_TIP_PRATO);
			if (agpmen) {
				let incagpmen = allplates.filter(ap => p.gpprato == ap.gpprato && p.COD_TIP_PRATO == ap.COD_TIP_PRATO);
				agpmen.qtdeotm = agpmen.qtdeotm ? agpmen.qtdeotm + 1 : 1;
				agpmen.consotm = 0;
				agpmen.puotm = 0;

				incagpmen.forEach(ap => {
					agpmen.consotm += parseFloat(ap.percentualConsumo);
					agpmen.puotm += parseFloat(ap.custoPerCapita);
				});

				agpmen.consotm = agpmen.consotm / incagpmen.length;
				agpmen.puotm = agpmen.puotm / incagpmen.length;

			} else {
				let newGpListItem = {
					//ID: p.gpprato,
					NM: p.gppratoNome,
					pivo: p.gpprato,
					COD_TIP_PRATO: p.COD_TIP_PRATO,
					qtdeotm: 1,
					consotm: parseFloat(p.percentualConsumo),
					puotm: parseFloat(p.custoPerCapita),
				};
				tpprat.gplist.push(newGpListItem);
				agpmen = tpprat.gplist.find(gplistItem => p.gpprato == gplistItem.pivo && p.COD_TIP_PRATO == gplistItem.COD_TIP_PRATO);
			}

			agpmen.plateList = agpmen.plateList || [];

			if (agpmen.pivo == p.gpprato) {
				let ptData = agpmen.plateList.find(ptListItem => ptListItem.pivo == p.codprato);
				if (!ptData) {
					agpmen.plateList.push({
						ID: `${p.codprato}`,
						NM: p.nomePrato,
						pivo: `${p.codprato}`,
						COD_TIP_PRATO: p.COD_TIP_PRATO,
						NRGRUPOPRATOSERV: p.gpprato,
					});
					ptData = agpmen.plateList.find(ptListItem => ptListItem.pivo == p.codprato);
				}
				let prato = ptData;

				let incpts = allplates.filter(ap => p.gpprato == ap.gpprato && p.COD_TIP_PRATO == ap.COD_TIP_PRATO && prato.pivo == ap.codprato);

				prato.qtdeotm = prato.qtdeotm ? prato.qtdeotm + 1 : 1;
				prato.consotm = 0;
				prato.puotm = 0;

				incpts.forEach(ap => {
					prato.consotm += parseFloat(ap.percentualConsumo);
					const VLR_CUSTO_PRATO = parseFloat(ap.VLR_CUSTO_PRATO)
					const percentualConsumo = ap.percentualConsumo
					const comensaisDia = ap.comensais
					const puotm = (percentualConsumo / 100 * comensaisDia) * VLR_CUSTO_PRATO

					prato.puotm += puotm
				});

				prato.consotm = prato.consotm / incpts.length;
				prato.puotm = prato.puotm / comensaisDIVTotal;
			}

		} else {
			console.log(p.COD_TIP_PRATO);
			// console.log(tpprat);
			// console.log(agpmen);
			console.log('\n');
		}
	});
	let data = [];
	incidenciaTabela.forEach(i => {
		let incCopy = JSON.parse(JSON.stringify(i));
		delete incCopy.gplist;

		incCopy.style = {
			'font': {
				'bold': true
			},
			fill: {
				type: 'pattern',
				pattern: 'solid',
				fgColor: {
					argb: 'FFa6a6a6'
				}
			},
			numFmt: "0.00000"
		};
		const incCopyMediaPU = parseFloat(incCopy.mediaPU)
		incCopy.cons = parseFloat(incCopy.cons) || null;
		incCopy.consotm = incCopy.consotm && parseFloat(incCopy.consotm) || null;
		incCopy.pu = parseFloat(incCopy.pu) || null;
		incCopy.mediaPU = incCopyMediaPU && incCopyMediaPU || null;
		incCopy.puotm = incCopy.puotm && parseFloat(incCopy.puotm) || null;
		incCopy.puotmmediapu = (incCopy.puotm && incCopy.mediaPU) ? parseFloat(incCopy.puotm) - parseFloat(incCopy.mediaPU) : incCopy.puotm || parseFloat(incCopy.mediaPU) * -1;
		incCopy.puotmmediapu = incCopy.puotmmediapu ? parseFloat(incCopy.puotmmediapu) : null;

		incCopy.puotmmescorrente = (incCopy.puotm && incCopy['pu' + meses[meses.length - 1]]) ? parseFloat(incCopy.puotm) - parseFloat(incCopy['pu' + meses[meses.length - 1]]) : incCopy.puotm || parseFloat(incCopy['pu' + meses[meses.length - 1]]) * -1;
		incCopy.puotmmescorrente = incCopy.puotmmescorrente ? parseFloat(incCopy.puotmmescorrente) : null;

		let gpList = i.gplist || [];
		let gpFinalList = [];
		gpList.forEach(igp => {
			const igpMediaPU = parseFloat(igp.mediaPU)
			igp.cons = parseFloat(igp.cons) || null;
			// igp.consotm = igp.consotm && parseFloat(igp.consotm) || null;
			igp.pu = parseFloat(igp.pu) || null;
			igp.mediaPU = igpMediaPU && igpMediaPU || null;
			igp.puotm = igp.puotm && parseFloat(igp.puotm) || null;
			igp.puotmmediapu = (igp.puotm && igp.mediaPU) ? parseFloat(igp.puotm) - parseFloat(igp.mediaPU) : igp.puotm || parseFloat(igp.mediaPU) * -1;
			igp.puotmmediapu = igp.puotmmediapu ? parseFloat(igp.puotmmediapu) : null;

			igp.puotmmescorrente = (igp.puotm && igp['pu' + meses[meses.length - 1]]) ? parseFloat(igp.puotm) - parseFloat(igp['pu' + meses[meses.length - 1]]) : igp.puotm || parseFloat(igp['pu' + meses[meses.length - 1]]) * -1;
			igp.puotmmescorrente = igp.puotmmescorrente ? parseFloat(igp.puotmmescorrente) : null;
			igp.style = {
				fill: {
					type: 'pattern',
					pattern: 'solid',
					fgColor: {
						argb: 'FFbfbfbf'
					}
				},
				numFmt: "0.00000"
			}

			gpFinalList.push(igp);

			let plateList = igp.plateList || [];
			let consotmSum = 0,
				plateCount = 0
			// let puotmAcc = 0
			plateList.forEach(ipl => {
				const iplMediaPU = parseFloat(ipl.mediaPU)
				ipl.cons = parseFloat(ipl.cons) || null;
				ipl.consotm = ipl.consotm && parseFloat(ipl.consotm) || null;
				ipl.pu = ipl.pu && parseFloat(ipl.pu) || null;
				ipl.mediaPU = iplMediaPU && iplMediaPU || null;
				ipl.puotm = ipl.puotm && parseFloat(ipl.puotm) || null;
				ipl.puotmmediapu = (ipl.puotm && ipl.mediaPU) ? parseFloat(ipl.puotm) - parseFloat(ipl.mediaPU) : ipl.puotm || parseFloat(ipl.mediaPU) * -1;
				ipl.puotmmediapu = ipl.puotmmediapu ? parseFloat(ipl.puotmmediapu) : null;

				ipl.puotmmescorrente = (ipl.puotm && ipl['pu' + meses[meses.length - 1]]) ? parseFloat(ipl.puotm) - parseFloat(ipl['pu' + meses[meses.length - 1]]) : ipl.puotm || parseFloat(ipl['pu' + meses[meses.length - 1]]) * -1;
				ipl.puotmmescorrente = ipl.puotmmescorrente ? parseFloat(ipl.puotmmescorrente) : null;
				ipl.style = {
					numFmt: "0.00000"
				}
				gpFinalList.push(ipl);

				if (ipl.consotm !== null) {
					consotmSum += parseFloat(ipl.consotm)
					plateCount++
				}
			});

			const groupConsotm = consotmSum / plateCount
			igp.consotm = groupConsotm || null
			const puotmPlateSum = plateList.reduce((accumulator, plate) => {
				const sumSubject = plate.puotm || 0
				accumulator += sumSubject
				return accumulator
			}, 0)
			igp.puotm = puotmPlateSum || null

		});

		const puotmGroupSum = gpList.reduce((accumulator, plateGroup) => {
			const sumSubject = plateGroup.puotm || 0
			accumulator += sumSubject
			return accumulator
		}, 0)
		incCopy.puotm = puotmGroupSum || null

		if (mediaIncidenciaTipoPrato[incCopy.COD_TIP_PRATO]) {
			let incidencias = contIncidenciaTipoPrato[incCopy.COD_TIP_PRATO];
			let total = mediaIncidenciaTipoPrato[incCopy.COD_TIP_PRATO];
			incCopy.consotm = total / incidencias
		} else {
			incCopy.consotm = null
		}


		data.push(incCopy);
		data = data.concat(gpFinalList);
		// data.push([]);
		let dashes = [];
		label.forEach(l => {
			dashes.push('--');
		});
		data.push(dashes);
		// data.push([]);
	});
	incidenciaTabela = null;
	meses = null;
	return {
		label,
		data
	};
};

let generatelogBuracosExcel = function (datas) {

	let label = [
		{
			header: "Tipo de Prato",
			key: "TP"
		},
		{
			header: "Grupo de Prato",
			key: "GP"
		},
		{
			header: 'Freq. Minima/Mês',
			key: 'freqMin'
		},
		{
			header: 'Freq. Máxina/Mês',
			key: 'freqMax'
		},
		{
			header: 'Freq. Máx. Semana',
			key: 'freqMaxSem'
		},
		{
			header: 'Nº Utilizado',
			key: 'utilizado'
		},
		{
			header: 'Nº Utilizado Semana',
			key: 'utilizadoSemana'
		},
		{
			header: '',
			key: 'warning'
		}
	];
	
	const newArrExcel = [];
      datas.forEach((data) => {
		const dateRow = data.dia;
		newArrExcel.push({'TP': 'Dia ' + dateRow, 'GP': '', 'freqMin': '', 'freqMax': '', 'freqMaxSem': '', 'utilizado': '', 'utilizadoSemana': ''});

        data.logBuracos && data.logBuracos.seqFaltantes.forEach((prato) => {
          const nmPrato = prato.nometipoprato;
		  let freqCont = 0;
		  newArrExcel.push({'TP': nmPrato, 'GP': '', 'freqMin': '', 'freqMax': '', 'freqMaxSem': '', 'utilizado': '', 'utilizadoSemana': ''});
		
		  prato.NUM_GRP_PRATO.forEach((grpPrato) => {
            const freq = data.logBuracos && data.logBuracos.frequencias.find(element => element.NUM_GRP_PRATO == grpPrato);
            if(freq != undefined) {
			  freqCont = freqCont+1;
              const momentDateRow = moment(dateRow, "DD/MM/YYYY");
              if(momentDateRow.format('dddd') == 'Sunday') momentDateRow.add('d', 1);
              const numberWeek = momentDateRow.format('WW');

			  let numberUsage = freq.curWeekUsage && freq.curWeekUsage[numberWeek] || 0;
			  numberUsage = numberUsage.toString();
			  if (numberUsage == freq.MAX_SEM_GRP) {
				numberUsage = numberUsage + ' *';
			  }

			  freq.cur = freq.cur || 0;
			  freq.cur = freq.cur.toString();
			  if(freq.cur == freq.MAX_MES_GRP) {
				freq.cur = freq.cur + ' *';
			  }
			  
			  newArrExcel.push({
					'TP': '',
					'GP': freq.NOME_GRUPO,
				  'freqMin': freq.MIN_MES_GRP, 
				  'freqMax': freq.MAX_MES_GRP, 
				  'freqMaxSem': freq.MAX_SEM_GRP, 
				  'utilizado': freq.cur || 0, 
				  'utilizadoSemana': numberUsage
				});
            }
		  });
		  
		  // Se o tipo de prato nao possui frequencias ele e removido
		  if(freqCont == 0) newArrExcel.pop();
		}); 
		
		if(newArrExcel[newArrExcel.length - 1].TP.indexOf('Dia') != -1) {
			// Se o unico dado do conjunto for a data ela e removida
			newArrExcel.pop();
		} else {
			// Adicionar espaco no final de cada conjunto no excel
			let dashes = [];
			label.forEach(l => {
				dashes.push('--');
			});
			newArrExcel.push(dashes);
		}
	});
		newArrExcel.push({
			'TP': '', 'GP': '','freqMin': '', 'freqMax': '', 'freqMaxSem': '', 'utilizado': '', 'utilizadoSemana': '', 'warning': '* Grupo já atingiu para semana ou para o mês'
		});
		newArrExcel.push({
			'TP': '', 'GP': '','freqMin': '', 'freqMax': '', 'freqMaxSem': '', 'utilizado': '', 'utilizadoSemana': '', 'warning': 'Ação Sugerida: Verifique a quantidade de frequência máxima do mês/semana.'
		});
		newArrExcel.push({
			'TP': '', 'GP': '','freqMin': '', 'freqMax': '', 'freqMaxSem': '', 'utilizado': '', 'utilizadoSemana': '', 'warning': 'Ação Sugerida: Para grupos que não atingiram o máximo da semana/mês, verifique as repetições do grupo nos dias da semana.'
		});

	return {
		label,
		newArrExcel
	};
};

const serviceInstance = {
	addIncidencia_tp_gp_prato,
	generateCardExcell,
	generateCompExcell,
	generatelogBuracosExcel,
	feedFreqData,
	feedINGData
};

export default serviceInstance;
